import { Router } from 'express';
import axios from 'axios';
import { CONSTANTS_GX, TEXT_CONSTANTS } from '../constants';
import { Ticker, PayType, OrderStatus, User } from '../models_nosql';
import {
	handlerTotalBalance,
	getMerchantOrders,
	getUserPayMethods,
	getMerchantAdvs,
	getArraySortedByProp,
	getArrayFilteredByProp,
	getOrderDetails,
	getTickerPriceUSDT,
	checkOrderInDB,
	insertOrderToDB,
	getP2POrders,
	getSpotOrders,
	getP2POrdersNomalized,
	getMerchantAdvsNomalized,
	getMerchantOrdersNomalized,
	getSpotOrdersNomalized,
	getBalancesNormalized,
	getPayMethodProps,
	getPayMethodPropsReverse,
	getPaySubAccount,
	getSingleUserProperty,
	consoleProcessed,
	getOrderDetailsNomalized,
	getObjectRequestParams,
} from '../common';
const {
	SHORT_NAME,
	GET_P2P_BALANCE,
	GET_P2P_ORDERS,
	GET_MERCHANT_ORDERS,
	GET_MERCHANT_ORDER_DETAILS,
	GET_MERCHANT_ADVS,
	CHANGE_STATUS_ADVS,
	GET_ADV_DETAIL,
	UPDATE_DETAILS_ADV,
	GET_HISTORY_SPOT_ORDERS,
	GET_ACTIVE_SPOT_ORDERS,
	GET_MERCHANT_ADV_PAYMENTS,
	GET_MERCHANT_DETAILS,
} = CONSTANTS_GX;

export const ordersRouter_GX = Router();

// получение балансов
ordersRouter_GX.post('/get-balances', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;
	const user = await User.findOne({ _id: userId });

	const objParams = {
		userId,
		shortName,
		prefix: `balance_${shortName}`,
		constants: CONSTANTS_GX,
		// apiKeys,
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		additionals: {},
	};

	const totalBalance = await handlerTotalBalance(objParams);

	return res.status(200).json({
		success: totalBalance.p2pBalance.length === 0 ? false : true,
		balances: totalBalance,
		message:
			totalBalance.p2pBalance.length === 0
				? `${shortName}: ${TEXT_CONSTANTS.BALANCE_ER}`
				: `${shortName}: ${TEXT_CONSTANTS.BALANCE_OK}`,
	});
});

// получение массива объявлений
ordersRouter_GX.post('/merchant-advs', async (req, res) => {
	const { userId, shortName, exchangeId, objParams } = req.body;
	const user = await User.findOne({ _id: userId });
	const requestHeaderGX = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			withCredentials: true,
			method: GET_MERCHANT_ADVS.method,
			url: GET_MERCHANT_ADVS.url,
			data: null,
			headers: {
				Authorization: `Bearer ${requestHeaderGX.token}`,
			},
		},
	};

	const arrData = await getMerchantAdvs(params);
	const arrPayTypes = await PayType.find();
	// console.log(arrData);
	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// merchantAdvs: [],
			merchantAdvs:
				arrData.length !== 0
					? getMerchantAdvsNomalized(
							arrData,
							{
								userId,
								exchangeId,
								prefix: shortName,
							},
							arrPayTypes
					  )
					: [],
			userPayMethods: [],
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_ER}`,
	});
});

// изменение статуса объявления (-ий) мерчанта
ordersRouter_GX.post('/adv-status', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_STATUS_ER}`,
	});
});

// получение редактируемого объявления мерчанта
ordersRouter_GX.post('/adv-edit', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_EDIT_ER}`,
	});
});

// обновление редактируемого объявления
ordersRouter_GX.post('/adv-update', async (req, res) => {
	res.status(400).json({
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_UPDATE_ER}`,
	});
});

// получение массива p2p-ордеров стакана
ordersRouter_GX.post('/p2p', async (req, res) => {
	const { userId, exchangeId, shortName, objParams } = req.body;
	const { fiat, arrPayments, sideType, amount } = objParams;

	const arrPayTypes = await PayType.find();
	// проверка amount на 0 и минус
	const transAmount = Number(amount) > 0 ? `&amount=${amount}` : '';
	const tradeType = sideType === 'BUY' ? 'sell' : 'buy';

	const paymentIdx =
		arrPayments.length === 0
			? ['']
			: arrPayments.map((item, index) => {
					return getPayMethodPropsReverse(
						exchangeId,
						'payName', // payId or payName
						item, // internalPayMethod
						arrPayTypes
					);
			  });
	const user = await User.findOne({ _id: userId });
	const requestHeaderHB = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			// withCredentials: true,
			method: GET_P2P_ORDERS.method,
			url: '',
			data: null,
			headers: {
				'access-control-allow-credentials': true,
				'Access-Control-Allow-Origin': '*',
				'content-type': 'application/json;charset=UTF-8',
			},
		},
	};

	let arrData = [];
	for (let i = 0; i < paymentIdx.length; i++) {
		const strURL = `direction=${tradeType}&payment_method=${
			paymentIdx[i]
		}&currency=${fiat.toLowerCase()}${transAmount}`;
		params.config.url = encodeURI(`${GET_P2P_ORDERS.url}?${strURL}`);
		const result = await getP2POrders(params);
		arrData = arrData.concat(
			getP2POrdersNomalized(
				result,
				{
					userId,
					exchangeId,
					prefix: shortName,
					payMethod: arrPayments[i],
				},
				arrPayTypes
			)
		);
	}

	// отсекаем дубли
	// const arrUniqueData = getArrayFilteredByProp(arrData, 'id');
	// сортировка DESC or ASC
	const arrDataSorted = getArraySortedByProp(
		shortName,
		arrData,
		tradeType
	);

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// p2pOrders: [],
			p2pOrders: arrData.length !== 0 ? arrDataSorted : [],
			tickers: await Ticker.find(),
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.P2P_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.P2P_ORDERS_ER}`,
	});
	// let arrData = [];
	// let success = true;
	// let message = `${SHORT_NAME} ${TEXT_CONSTANTS.P2P_ORDERS_OK}`;
	// const arrPayMethods = req.body.payment_method;

	// const params = {
	// 	amount: req.body.amount,
	// 	direction: req.body.direction,
	// 	payment_method: [],
	// 	currency: req.body.currency,
	// 	// token: req.body.requestHeader.token,
	// };

	// for (let i = 0; i < arrPayMethods.length; i++) {
	// 	params.payment_method = arrPayMethods[i];
	// 	const result = await getP2POrders_GX(GET_P2P_ORDERS, params);
	// 	arrData = arrData.concat(result);
	// }

	// // проверка - не пустой ли полученный массив
	// if (arrData.length !== 0) {
	// 	message = `${arrData.length} ${message}`;
	// } else {
	// 	success = false;
	// 	message = `${SHORT_NAME} ${TEXT_CONSTANTS.P2P_ORDERS_ER}`;
	// }

	// // отсекаем дубли
	// const arrUniqueData = getArrayFilteredByProp(arrData, 'id');

	// return res.status(200).json({
	// 	success,
	// 	data: {
	// 		p2pOrders: getArraySortedByProp(
	// 			SHORT_NAME,
	// 			arrUniqueData,
	// 			params.direction
	// 		),
	// 		tickers: await Ticker.find(),
	// 	},
	// 	message,
	// });
});

// получение массива текущих merchant-ордеров
ordersRouter_GX.post('/merchant-orders', async (req, res) => {
	const { userId, exchangeId, shortName, objParams } = req.body;

	const user = await User.findOne({ _id: userId });
	const requestHeaderGX = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			// withCredentials: true,
			method: GET_MERCHANT_ORDERS.method,
			url: `${GET_MERCHANT_ORDERS.url}?limit=${objParams.rows}`,
			data: null,
			headers: { Authorization: `Bearer ${requestHeaderGX.token}` },
		},
	};

	const arrData = await getMerchantOrders(params);
	const arrPayTypes = await PayType.find();
	const arrOrderStatus = await OrderStatus.find();

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		// data: [],
		data:
			arrData.length !== 0
				? getMerchantOrdersNomalized(
						arrData,
						{
							userId,
							exchangeId,
							prefix: shortName, // 'MG'
						},
						arrPayTypes,
						arrOrderStatus
				  )
				: [],
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.USER_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ORDERS_ER}`,
	});
});

// получение сведений об мерчанте и его объявлениях по id
ordersRouter_GX.get('/merchant-details/:id', async (req, res) => {
	const merchantId = req.params.id;
	const axiosRequestConfig = {
		method: GET_MERCHANT_DETAILS.method,
		url: `${GET_MERCHANT_DETAILS.url}?userNo=${merchantId}`,
		data: null,
		headers: null,
	};
	await axios(axiosRequestConfig)
		.then((response) => {
			// console.log(response.data)
			return res.status(200).json({
				success: true,
				data: response.data.data,
				message: 'Merchant details were successful loaded',
			});
		})
		.catch((error) => {
			res.status(400).json({
				error,
				message: 'Merchant details were not loaded',
			});
		});
});

// сохранение данных об merchant-ордере в БД по id
ordersRouter_GX.post('/save-user-orders', async (req, res) => {
	const arrTickers = await Ticker.find(); // тикеры и цены из БД
	const arrPayTypes = await PayType.find(); // типы оплаты из БД
	let countOrder = 0;

	const { userId, orders, typeOrder, shortName, exchangeId } = req.body;
	const user = await User.findOne({ _id: userId });
	const requestHeaderGX = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const headers = {
		// 'access-control-allow-credentials': true,
		// 'Access-Control-Allow-Origin': '*',
		// 'content-type': 'application/json;charset=UTF-8',
		Authorization: `Bearer ${requestHeaderGX.token}`,
	};

	// проверка наличия ордера в БД
	for (let i = 0; i < orders.length; i++) {
		if (orders[i] !== null) {
			const result = await checkOrderInDB(
				userId,
				typeOrder,
				orders[i],
				shortName
			);

			// Если ордера нет в БД
			if (result.isUnique) {
				const config = {
					method: GET_MERCHANT_ORDER_DETAILS.method,
					url: `${GET_MERCHANT_ORDER_DETAILS.url}${orders[i]}`,
					data: null,
					headers,
				};

				// получение данных об ордере с биржи
				const orderDetails = await getOrderDetails(
					config,
					shortName,
					typeOrder
				);

				const params = {
					userId,
					shortName,
					exchangeId,
					arrTickers,
					arrPayTypes,
					orderDetails,
				};

				// если orderDetails не пустой объект - подготовка к сохранению БД
				if (Object.keys(orderDetails).length !== 0) {
					// если статус ордера "Completed" вставляем в БД
					const newOrder =
						orderDetails.state === 'completed'
							? getOrderDetailsNomalized(params)
							: {};
					// если newOrder не пустой объект - сохраняем в БД
					if (Object.keys(newOrder).length !== 0) {
						await insertOrderToDB(typeOrder, newOrder);
						// console.log(`${countOrder} | Number: ${newOrder.orderId} | priceAssetUSDT: ${newOrder.priceAssetUSDT}`);
						++countOrder;
					}
				}
			}
		}
	}

	// log print
	consoleProcessed(userId, shortName, orders, countOrder, typeOrder);

	return res.status(200).json({
		success: true,
		message: `${shortName}: ${countOrder} inserted`,
	});
});

// получение массива активных spot-ордеров
ordersRouter_GX.post('/spot-orders-active', async (req, res) => {
	const { userId, exchange, exchangeId, shortName } = req.body;
	const arrTickers = await Ticker.find();
	let status = 200;

	// 	const user = await User.findOne({ _id: userId });
	// 	const requestHeader = getSingleUserProperty(
	// 		'requestHeader',
	// 		exchange,
	// 		user.properties
	// 	);

	// 	// проверям существуют ли куки на этом сервисе
	// 	if (requestHeader.userAgent === '') {
	// 		return res.status(status).json({
	// 			success: true,
	// 			message: `${SHORT_NAME}: requestHeader is empty`,
	// 			spotOrders: [],
	// 			tickers: await Ticker.find(),
	// 		});
	// 	}

	// const params = {
	// 	userId,
	// 	prefix: SHORT_NAME,
	// 	config: {
	// 		withCredentials: true,
	// 		method: GET_ACTIVE_SPOT_ORDERS.method,
	// 		url: `${GET_ACTIVE_SPOT_ORDERS.url}?limit=21&s=getOrders&from_order_id=0`,
	// 		data: null,
	// 		headers:{
	// 			'Access-Control-Allow-Origin': '*',
	// 			'accept-encoding': 'gzip, deflate, br',
	// 			'user-agent': 'PostmanRuntime/7.29.0',
	// 			cookie: requestHeader.cookie,
	// 			usertoken: requestHeader.usertoken,
	// 		},
	// 	},
	// };

	// 	const arrActiveSpots = await getSpotOrders(params);
	const arrActiveSpots = [];

	return res.status(status).json({
		success: true,
		message: `${shortName}: 0 ${TEXT_CONSTANTS.SPOT_ORDERS_OK}`,
		spotOrders: [],
		tickers: arrTickers,
	});
});

// сохранение spot-ордеров в БД
ordersRouter_GX.post('/spot-orders-history', async (req, res) => {
	let message;
	let success = true;
	let status = 200;
	let countOrder = 0;
	const {
		userId,
		exchange,
		exchangeId,
		shortName,
		typeOrder,
		params,
	} = req.body;

	const user = await User.findOne({ _id: userId });
	const requestHeader = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const objParams = {
		userId,
		prefix: `history_${shortName}`,
		// apiKeys,
		requestHeader,
		constants: CONSTANTS_GX,
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(objParams);
	const spotArray = await getSpotOrders(objReqParams);
	const arrTickers = await Ticker.find();

	const spotOrders = getSpotOrdersNomalized(
		spotArray,
		{
			userId,
			shortName,
			exchangeId,
			flag: 'history_GX',
		},
		arrTickers
	);

	if (spotOrders.length !== 0) {
		// проверка наличия ордера в БД
		for (let i = 0; i < spotOrders.length; i++) {
			const result = await checkOrderInDB(
				spotOrders[i].userId,
				typeOrder,
				spotOrders[i].orderId,
				spotOrders[i].exchange
			);

			// Если ордера нет в БД вставляем
			if (result.isUnique) {
				// если newSpotOrder не пустой объект - сохраняем в БД
				if (Object.keys(spotOrders[i]).length !== 0) {
					await insertOrderToDB('SPOT', spotOrders[i]);
					// console.log(
					// 	`${countOrder} | orderId: ****${spotOrders[i].orderId.slice(
					// 		-5
					// 	)} inserted`
					// );
					++countOrder;
				}
			}
			// else console.log(`Order ${spotOrders[i].orderId} is not Unique`);
		}
		if (countOrder === 0) {
			success = false;
			message = `${shortName}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_NO}`;
		} else {
			success = true;
			message = `${shortName}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_OK}`;
		}
	} else {
		success = false;
		message = `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
	}

	// log print
	consoleProcessed(userId, shortName, spotOrders, countOrder, typeOrder);

	return res.status(status).json({
		success,
		message,
	});
});
